{  ꥪ⮬  ᪨}

unit Obj;

interface

{ᠭ ᢮  ⮤ ꥪ}

type Figur=object
       X, Y, Num: Integer;
       LastX, LastY: Integer;
       FirstX, FirstY: Integer;
       Color: Byte;
       Width, Height: Integer;
       constructor Init;
       procedure Draw; virtual;
       procedure Run;
       procedure Done; virtual;
       private procedure Restore;
       procedure Drag;
     end;

implementation

uses Graph, Mouse, Crt;

{楤 樠樨  ꥪ}

constructor Figur.Init;
begin
  X:=0;
  Y:=0;
  Num:=0;
  LastX:=0;
  LastY:=0;
  Color:=15;
  Width:=100;
  Height:=100;
  Draw;
end;

{㠫 ⮤ ᮢ ꥪ}

procedure Figur.Draw;
  var Size: Word;
begin
  SetColor(Color);
end;

{⠭  ࠭}

procedure Figur.Restore;
  var C: Byte;
begin
  C:=Color;
  Color:=0;
  Draw;
  Color:=C;
end;

{楤 ᪨ ꥪ}

procedure Figur.Drag;
  var MouseX, MouseY, Button: Word;
begin
  repeat

{⥭ न }

    MouseRead(MouseX, MouseY, Button);

{᫨ न  ,  ६ ꥪ}

    if (LastX<>MouseX) or (LastY<>MouseY) then begin
      MouseHide;
      Restore;
      X:=MouseX-FirstX;
      Y:=MouseY-FirstY;
      Draw;
      MouseShow;
    end;
    LastX:=MouseX;
    LastY:=MouseY;

{     㤥 饭   }

  until Button=0;
end;

{᭮ ⮤  ࠡ  ꥪ⮬}

procedure Figur.Run;
  var MouseX, MouseY, Button: Word;
      C: Char;
begin

{  }

  MouseShow;

{ न }

  MouseRead(MouseX, MouseY, Button);

{᫨  ,    }

  if KeyPressed then C:=ReadKey;

{᫨   Enter,  㢥 - 㦭⥩}

  if C=#13 then begin
    Num:=Num+1;
    if Num>10 then Num:=10;
    Draw;
  end;

{᫨   Backspace,  㬥 - 㦭⥩}

  if C=#27 then begin
    Color:=0;
    Restore;
    Num:=Num-1;
    if Num<0 then Num:=0;
    Color:=15;
    Draw;
  end;

{᫨ न  室  न⠬ ꥪ 
    ,  ६ ꥪ}

  if (MouseX>X) and (MouseY>Y)
  and (MouseX<X+Width) and (MouseY<Y+Height)
  and (Button=1) then begin
    FirstX:=MouseX-X;
    FirstY:=MouseY-Y;
    Drag;
  end;
end;

{楤    }

procedure Figur.Done;
begin
  MouseHide;
end;

end.